searchNodes=[{"doc":"Documentation for Concur .","ref":"Concur.html","title":"Concur","type":"module"},{"doc":"Hello world. Examples iex&gt; Concur . hello ( ) :world","ref":"Concur.html#hello/0","title":"Concur.hello/0","type":"function"},{"doc":"Producer/consumer implementation of a pre-processing stream, with a limited buffer size.","ref":"Concur.BufferedStream.html","title":"Concur.BufferedStream","type":"module"},{"doc":"","ref":"Concur.BufferedStream.html#map/3","title":"Concur.BufferedStream.map/3","type":"function"},{"doc":"","ref":"Concur.BufferedStream.html#t:opt/0","title":"Concur.BufferedStream.opt/0","type":"type"},{"doc":"Stateful queue abstraction. Often it's necessary to deal with a stateful queue, this abstraction is built using both Agents and Erlang's :queue module. Examples For example, the following uses the Queue by pushing and popping elements from it: { :ok , queue } = Queue . start ( ) Queue . push ( queue , 1 ) Queue . push ( queue , 2 ) Queue . push ( queue , 3 ) Queue . pop ( queue ) # =&gt; {:value, 1} Queue . pop ( queue ) # =&gt; {:value, 2} Queue . pop ( queue ) # =&gt; {:value, 3} Queue . pop ( queue ) # =&gt; :empty","ref":"Concur.Queue.html","title":"Concur.Queue","type":"module"},{"doc":"","ref":"Concur.Queue.html#is_empty?/1","title":"Concur.Queue.is_empty?/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#pop/1","title":"Concur.Queue.pop/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#push/2","title":"Concur.Queue.push/2","type":"function"},{"doc":"","ref":"Concur.Queue.html#start/1","title":"Concur.Queue.start/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#start_link/1","title":"Concur.Queue.start_link/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#stop/1","title":"Concur.Queue.stop/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#to_list/1","title":"Concur.Queue.to_list/1","type":"function"},{"doc":"","ref":"Concur.Queue.html#t:queue/0","title":"Concur.Queue.queue/0","type":"type"},{"doc":"Simple GenServer-based semaphores implementation, with the full semaphore functions P ( wait ) and V ( signal ).","ref":"Concur.Semaphore.html","title":"Concur.Semaphore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Concur.Semaphore.html#child_spec/1","title":"Concur.Semaphore.child_spec/1","type":"function"},{"doc":"","ref":"Concur.Semaphore.html#new/1","title":"Concur.Semaphore.new/1","type":"function"},{"doc":"Asynchronously increment the value of the semaphore by 1 .","ref":"Concur.Semaphore.html#signal/1","title":"Concur.Semaphore.signal/1","type":"function"},{"doc":"Stops the semaphore process.","ref":"Concur.Semaphore.html#stop/1","title":"Concur.Semaphore.stop/1","type":"function"},{"doc":"Synchronously wait for the semaphore to be available. Decrement the semaphore by 1 once it is.","ref":"Concur.Semaphore.html#wait/1","title":"Concur.Semaphore.wait/1","type":"function"},{"doc":"","ref":"Concur.Semaphore.html#t:limit/0","title":"Concur.Semaphore.limit/0","type":"type"},{"doc":"","ref":"Concur.Semaphore.html#t:t/0","title":"Concur.Semaphore.t/0","type":"opaque"},{"doc":"Concurrency and streams utilities. This library embeds multiple modules for dealing with concurrency and Elixir streams. Including: Semaphores","ref":"readme.html","title":"Concur","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding concur to your list of dependencies in mix.exs : def deps do [ { :concur , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"Concur - Installation","type":"extras"},{"doc":"Semaphore The Concur.Semaphore provides a full semaphores implementation for it to be used by either concurrent or synchronous code. It contains the two semaphore primitives: wait and signal . Here's an example: alias Concur.Semaphore , as : Sem sem = Sem . new ( 1 ) # Process 1 Sem . wait ( ) # =&gt; Proceeds to obtain the semaphore and continue executing # Process 2 Sem . wait ( ) # =&gt; Blocks until the semaphore is unblocked # Process 1 Sem . signal ( ) # =&gt; Unblocks semaphore. Process 2 continues executing Buffered stream The Concur.BufferedStream provides way to map enumerable values in advance up to a certain amount of values ( buffer_size: 4 option). These values can also be loaded asynchronously (with async?: true option), meaning we don't have to wait for the previous value to be computed to calculate the next one. alias Concur.BufferedStream , as : BS [ 1 , 2 , 3 ] |&gt; BufferedStream . map ( fn i -&gt; # really long function that will take time to compute # which will be executed in advance for up to 10 values end , buffer_size : 10 ) |&gt; Enum . map ( &amp; IO . inspect / 1 ) [ 1 , 2 , 3 ] |&gt; BufferedStream . map ( fn i -&gt; # ... end , buffer_size : 10 , async? : true ) Stateful Queue The Concur.Stateful.Queue module allows for a stateful FIFO behavior. alias Concur.Stateful.Queue { :ok , queue } = Queue . start ( ) Queue . push ( queue , 1 ) Queue . push ( queue , 2 ) Queue . push ( queue , 3 ) Queue . pop ( queue ) # =&gt; {:value, 1} Queue . pop ( queue ) # =&gt; {:value, 2} Queue . pop ( queue ) # =&gt; {:value, 3} Queue . pop ( queue ) # =&gt; :empty","ref":"readme.html#usage","title":"Concur - Usage","type":"extras"},{"doc":"See LICENSE","ref":"readme.html#license","title":"Concur - LICENSE","type":"extras"}]